bits 16
org 100h

_main:	jmp NonTSRmain

IntVecSignature equ 0x4E49414A ; 'JAIN'

;;;;;;;;;;;;;;;;;;;;;
;;; FONT GUARDIAN ;;;
;;;;;;;;;;;;;;;;;;;;;
I10sig: dd IntVecSignature
GotoOldI10:
	db 0EAh ; jmp far
OldI10	dw 10h*4,0
INT10:	push ax
	 and ax, 0xFF7F
	 cmp ax, 0003h
	pop ax
	ja GotoOldI10
	pushf
	call far [cs:OldI10]
	pusha
	 call InstallFont
	popa
	iret

InstallFont:
	push es
	 push cs
	 pop es
	 ;    for(next=0; next<256; ) {
	 ;        if(!special(next))
	 ;            ++next;
	 ;        else {
	 ;            begin=next
	 ;            do ++next; while(next < 256 && special(next));
	 ;            count = next-begin
	 ;            process(begin, count)
	 ;    }   }
	 mov bp, FontData
	 xor ax, ax
if_findbegin:
	 call TestSpecialChar
	 jz if_beginnext
	 push ax
if_findend:
	  inc ax
	  test ah, ah
	  jnz if_foundend
	  call TestSpecialChar
	  jnz if_findend
if_foundend:
	 pop dx       ; First character
	 mov cx, ax   ; Next character to be tested
	 sub cx, dx   ; Count
	 xchg si,ax
	  mov ax, 1100h
	  mov bx, 1000h ; 16 bytes per character, block 0 in map 2
	  ; lea bp, [FontData + cx*16]
	  int 10h
	  shl cx, 4
	  add bp, cx
	 xchg si,ax
	 dec ax
if_beginnext:
	 ;inc ax
	 ;test ah,ah
	 ;jz if_findbegin
	 inc al
	 jnz if_findbegin
	pop es
	ret

TestSpecialChar:
	; Input: al = character. Clobbers bx,cl,dl
	mov bx, ax
	mov cl, bl
	and cl, 7
	shr bx, 3
	and bx, 1Fh
	mov dl, [cs:RedefinedCharMap+bx]
	mov bl, 1
	shl bl, cl
	test dl, bl
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; INPUT TRANSLATOR: INT 21 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INT 21 function 0B must be hooked because under DOSBox,
;; it just looks up keyboard buffer...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
I21sig: dd IntVecSignature
GotoOldI21:
	db 0EAh ; jmp far 
OldI21: dw 21h*4, 0
INT21:  cmp ah, 0x0B ; Get STDIN status
	jne GotoOldI21

	; Check if STDIN is CON
	push bx
	push dx
	push ax
	 mov ax, 4400h
	 xor bx, bx
	 pushf
	 call far [cs:OldI21] ; Get device information
	 mov al, 0x81
	 and dl, al
	 cmp dl, al   
	pop ax
	pop dx
	pop bx   
	jne GotoOldI21 ; Jump to standard 0B function if wasn't CON
	; Get key status using our INT 16h
	mov ah, 11h
	pushf
	push cs
	call INT16
	mov ax, 0x0BFF
	jnz I21gotchar
	xor al, al
I21gotchar:
	iret 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; INPUT TRANSLATOR: INT 16 ;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
EnableToggleKey1 equ 2915h ; section key on FI keyboard
EnableToggleKey2 equ 1B1Dh ; ctrl+] on US keyboard
EnableToggleKey3 equ 32E6h ; mu on DE keyboard

InputHistorySize      db 0
TranslationEnabled    db 0

I16sig: dd IntVecSignature
GotoOldI16:
	db 0EAh ; jmp far
OldI16	dw 16h*4,0
INT16:	call AnalyzeI16function
	jc Func1
	jnz GotoOldI16
Func0:  ; Get and wait for key
	mov [cs:I16mode], word Func0push-I16mode-2
	cmp word [cs:CurrentPtr], byte 0
	je InputHook0
Func0push:
	push bx
	 push ds
	  push cs
	  pop ds
	  mov bx, [cs:CurrentPtr]
	  movzx ax, byte [bx]
	  inc bx
	  cmp [bx], byte 0
	  jne DontReset
	  xor bx,bx
DontReset:
	  mov [CurrentPtr], bx
	  call PutInInputHistory
	 pop ds
	pop bx
GotKey:	mov ah, 0
	cmp al, 8
	je Got08
	cmp al, 13
	je Got13
	jmp Ret0
Got08:	mov ah, 0Eh
	jmp Ret0
Got13:	mov ah, 1Ch
	;jmp Ret0
Ret0:	iret

Func1:  ; Check if key is available. ZF=1 if NO key. Does not remove key from buffer.
	mov [cs:I16mode], word Func1push-I16mode-2
	cmp [cs:CurrentPtr], word 0
	je InputHook1
Func1push:
	mov al, [cs:0000h]
CurrentPtr equ $-2
NotIdle:
	and [esp+4], byte 0xBF
	jmp GotKey

Func1Idle:
	or [esp+4], byte 0x40
	iret

CallOldI16:
	pushf
	call far [cs:OldI16]
	ret

; Decide which INT16 function was called. ZF=Func0, CF=Func1, neither=other
AnalyzeI16function:
	cmp ah, 00h
	je DeterminedFunc0
	cmp ah, 10h   
	je DeterminedFunc0
	cmp ah, 20h
	je DeterminedFunc0
	cmp ah, 01h
	je DeterminedFunc1
	cmp ah, 11h
	je DeterminedFunc1
	cmp ah, 21h
	clc
	jne DeterminedFunc0 ;just a ret.
DeterminedFunc1:
	stc      
DeterminedFunc0:
	ret  

TestToggle:
	cmp ax, EnableToggleKey1
	je TestToggleEnd
	cmp ax, EnableToggleKey2
	je TestToggleEnd
	cmp ax, EnableToggleKey3
TestToggleEnd:
	ret

InputHookDisabledIret:
	call ResetInputHistory
	iret
InputHook1:
	call CallOldI16
	jz Func1Idle
	call TestToggle
	je Toggled1
	and [esp+4], byte 0xBF
	cmp [cs:TranslationEnabled], byte 0
	jz InputHookDisabledIret
	push ds
	 push cs
	 pop ds
	 mov [WhatWasThatInputAgain], ax
	 push bx
	  jmp TestInput
Toggled1:
	xor [cs:TranslationEnabled], byte 1
	or [esp+4], byte 0x40 ; set zero-flag (no input)
	; go and fetch the toggle-key from input buffer (passthru)
Toggled0:
	xor [cs:TranslationEnabled], byte 1
	mov ax, 1000h
InputHook0:
	call CallOldI16
	call TestToggle
	je Toggled0
	cmp [cs:TranslationEnabled], byte 0
	jz InputHookDisabledIret
	push ds
	 push cs
	 pop ds
	 mov [WhatWasThatInputAgain], ax
	 push bx
	  jmp TestInput
DefaultInput:
	  mov ax, word 0000h
WhatWasThatInputAgain equ $-2
	  cmp [cs:I16mode], word Func0push-I16mode-2
	  jne DefaultInputDontSave
	  call PutInInputHistory
DefaultInputDontSave:
	 pop bx
	 mov ax, [WhatWasThatInputAgain]
	pop ds
	iret
PutSequence:
	  pop word [CurrentPtr]
	  cmp [I16mode], word Func1push-I16mode-2
	  jne ps0
	  ; Because we're substituting the input,
	  ; call the BIOS function once to flush
	  ; the pending input key
	  mov ax, 1000h
	  call CallOldI16
ps0:	 pop bx
	pop ds
	db 0E9h ; jmp near
I16mode	dw 0    ; jmp I16mode

PutInInputHistory:
	cmp al, 0
	je ResetInputHistory
	mov bx, word InputHistory
InputHistoryHead equ $-2
	cmp al, 8
	je InputHistoryBackspace
	mov [bx], al
	cmp byte [InputHistorySize], 20
	jae pis1
	inc byte [InputHistorySize]
pis1:	inc bx
	cmp bx, InputHistoryEnd
	jne pis9
	mov bx, InputHistory
pis9:	mov word [InputHistoryHead], bx
	ret
InputHistoryBackspace:
	cmp bx, InputHistory
	je InputHistoryBackspaceWrap
	dec word [InputHistoryHead]
	jmp pis3
InputHistoryBackspaceWrap:
	mov word [InputHistoryHead], InputHistoryEnd-1
pis3:	cmp byte [InputHistorySize], 0
	jnz pis2
	dec byte [InputHistorySize]
pis2:	ret
ResetInputHistory:
	mov word [InputHistoryHead], InputHistory
	mov byte [InputHistorySize], 0
	ret

GetHistory1:	mov bx,1
		jmp GetHistory
GetHistory2:	mov bx,2
		jmp GetHistory
GetHistory3:	mov bx,3
		jmp GetHistory
GetHistory4:	mov bx,4
		jmp GetHistory
GetHistory5:	mov bx,5
		;jmp GetHistory
GetHistory:
	cmp bl, [InputHistorySize]
	mov al, 0
	jae GetInputHistoryEOF
	sub bx, [InputHistoryHead]
	neg bx
	cmp bx, InputHistory
	jae NotInputHistoryWrap
	add bx, InputHistoryEnd-InputHistory
NotInputHistoryWrap:
	mov al, [bx]
GetInputHistoryEOF:
	ret
tolower:
	cmp al, 'A'
	jb GetInputHistoryEOF
	cmp al, 'Z'
	ja GetInputHistoryEOF
	add al, 'a' - 'A'
	ret

BinarySearchLoH1:	call GetHistory1
			jmp BinarySearchLo
BinarySearchLoH2:	call GetHistory2
			jmp BinarySearchLo
BinarySearchLoH3:	call GetHistory3
			jmp BinarySearchLo
BinarySearchLoH4:	call GetHistory4
			jmp BinarySearchLo
BinarySearchLoH5:	call GetHistory5
			;jmp BinarySearchLo
BinarySearchLo:		call tolower
			;jmp BinarySearch
BinarySearch:
	; searches AL in the data to come.
	; Data format:
	;          db NumItems
	;          dw DefaultJump
	;          db Items[]
	;          dw JumpTargets[]
	; Assume DS = CS
	; Uses:      BX
	;            DI (saved)
	;            DX (saved)
	;            AH
	pop bx
	push dx
	push di
	movzx dx, byte[bx]  ; dl=upper limit (exclusive), dh=lower limit
	; Note: yes, they are vice versa. This is intentional.
	; This way, we get hi=count, lo=0 with one instruction.
	jmp binarysearch_loop_assume_nonempty
binarysearch_larger:
	inc ah
	mov dh, ah
	;; jmp binarysearch_loop ;Redundant jump
binarysearch_loop:
	cmp dh, dl
	jae binarysearch_fail
binarysearch_loop_assume_nonempty:
	mov ah, dh
	add ah, dl
	shr ah, 1
	movzx di, ah
	cmp al, [bx+di+3]
	jnbe binarysearch_larger
binarysearch_smaller:
	mov dl, ah
	jne binarysearch_loop
	;; jmp binarysearch_match ;Redundant jump
binarysearch_match:
	movzx dx, byte[bx]
	add di, di ; di = ah*2
	add bx, dx ; skip over the character options
	lea bx, [bx+di+2] ; bx + ah*2 + dl + 3
binarysearch_fail:
	pop dx
	pop di
	jmp word [bx+1]



%include "data.asm"

InputHistory:
InputHistoryEnd equ InputHistory + 32

TSRend equ InputHistoryEnd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;; MAIN (NON-RESIDENT) ;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
UninstalledText:
	db 'JAINPUT unloaded.',13,10
	db '$'
InstalledText:
	db 'JAINPUT - Makeshift 8-bit Japanese IME for DOS',13,10
	db 'Copyright (C) 2011-03-03 Joel Yliluoma, http://iki.fi/bisqwit/',13,10
	db 'JAINPUT','Ѐ ҂؝Ǘ҂ֆ҂',0xFF
	db 32
	db 'Ɩ-҂- Ѐ : ', EnableToggleKey1 & 255
	db 13,10,'$'
UninstalledSegment equ CurrentPtr
I10ptr equ OldI10
I16ptr equ OldI16
I21ptr equ OldI21

LineIncrement equ NonTSRmain
NonTSRmain:
	mov es, [2Ch]
	mov ah, 49h
	int 21h

	;call ResetInputHistory
	call InstallFont

	mov ecx, [I10sig]

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ax, cs
	;mov ds, ax
	les di, [I16ptr]
	shl eax, 16
	mov ax, INT16
	cli
	push es
	 push si
	  les si, [es:di] ; Load old I16 pointer
	  cmp [es:si-9], ecx
	  je UninstallI16
AfterUninstallI16:
	 pop si
	pop es
	cmp [UninstalledSegment], word 0
	jne SkipI16install
	 xchg eax, [es:di]
	 mov [OldI16], eax
	 sti
SkipI16install:

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ax, cs
	;mov ds, ax
	les di, [I21ptr]
	shl eax, 16
	mov ax, INT21
	cli
	push es
	 push si
	  les si, [es:di] ; Load old I21 pointer
	  cmp [es:si-9], ecx
	  je UninstallI21
AfterUninstallI21:
	 pop si
	pop es
	cmp [UninstalledSegment], word 0
	jne SkipI21install
	 xchg eax, [es:di]
	 mov [OldI21], eax
	 sti
SkipI21install:

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ax, cs
	;mov ds, ax
	les di, [I10ptr]
	shl eax, 16
	mov ax, INT10
	cli
	push es
	 push si
	  les si, [es:di] ; Load old I10 pointer
	  cmp [es:si-9], ecx
	  je UninstallI10
AfterUninstallI10:
	 pop si
	pop es
	cmp [UninstalledSegment], word 0
	jne UninstalledExit
	 xchg eax, [es:di]
	 mov [OldI10], eax
	 sti

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ah, 0Fh
	int 10h
	; AH = number of character columns
	movzx ax, ah
	add ax, ax
	mov [LineIncrement], ax

	push ds
	 mov di, ax
	 shl di, 2
	 add di, ax
	 mov ax, 0xB800
	 mov ds, ax
	 sub di, 16*2
	 mov si, 17
	 mov ax, 0x0200
yloop:	 dec si
	 jz disploopdone
	 mov bp, 17
xloop:   dec bp
	 jz yloopnext
	 call TestSpecialChar
	 mov bx, ax
	 jz nspecial
special: mov bh, 6
nspecial:mov [di], bx
	 inc di
	 inc di
	 inc ax
	 jmp xloop
yloopnext:
	 sub di, 16*2
	 add di, [cs:LineIncrement]
	 jmp yloop
disploopdone:
	pop ds

	mov dx,InstalledText ; Display text
	mov ah,9
	int 21h
	mov dx, (((TSRend - _main) + 15) >> 4) + 10h
	mov ax, 3100h ; Calculate TSR size and do TSR.
	int 21h
UninstallI16:
	; Input: ES:SI = Address of INT16 routine of the JAINPUT instance to remove
	; Changes: DS, DI
	push ds
	 mov eax, [es:si-4]
	 lds di, [cs:I16ptr]
	 mov [di], eax ; Restore old INT
	pop ds
	sti
	mov [UninstalledSegment], es
	jmp AfterUninstallI16
UninstallI10:
	; Input: ES:SI = Address of INT10 routine of the JAINPUT instance to remove
	; Changes: DS, DI
	push ds
	 mov eax, [es:si-4]
	 lds di, [cs:I10ptr]
	 mov [di], eax ; Restore old INT
	pop ds
	sti
	mov [UninstalledSegment], es
	jmp AfterUninstallI10
UninstallI21:
	; Input: ES:SI = Address of INT21 routine of the JAINPUT instance to remove
	; Changes: DS, DI
	push ds
	 mov eax, [es:si-4]
	 lds di, [cs:I21ptr]
	 mov [di], eax ; Restore old INT
	pop ds
	sti
	mov [UninstalledSegment], es
	jmp AfterUninstallI21

UninstalledExit:
	sti
	mov es, [UninstalledSegment]
	mov ah, 49h ; Free the code segment
	int 21h
	push cs     ; Display text
	pop ds
	mov dx,UninstalledText
	mov ah,9
	int 21h
	mov ax, 4C00h ; Exit
	int 21h

End:;
